= Changelog archive =

This is an archive of older changelog entries. Most recent entries are maintained in readme.txt

= 4.1.0 =

Release post: [https://webberzone.com/announcements/contextual-related-posts-v4-1-0/](https://webberzone.com/announcements/contextual-related-posts-v4-1-0/)

* Features:
    * New Wizard to guide users through the setup process.

* Modifications:
    * Renamed `CRP_VERSION`, `CRP_PLUGIN_FILE`, `CRP_PLUGIN_DIR` and `CRP_PLUGIN_URL` constants to `WZ_CRP_VERSION`, `WZ_CRP_PLUGIN_FILE`, `WZ_CRP_PLUGIN_DIR` and `WZ_CRP_PLUGIN_URL` respectively to avoid conflicts with other plugins.
    * New function `crp_get_blog_option()` to fetch an option from a specific blog in WordPress multisite.
    * Better handling of options if they haven't been set.
	* Fulltext indexes are now named `wz_title_content`, `wz_title`, and `wz_content` to ensure compatibility and optimize database space, especially when using Contextual Related Posts. After updating to this version, please recreate the indexes to benefit from the changes—until then, the plugin will use the previous index names.
    * [Pro] Improved the UI and functionality of the Custom Table indexing process.
    * [Pro] Multisite Settings page for Enhanced Content Search Index (ECSI) has been modified.

* Bug fixes:
    * Fixed ordering issue on pages when "Same taxonomies" is selected.
    * Set the postid if it's different from the queried object in the Core Query class.
    * Fixed conflict with WPML showing the current post incorrectly.
	* Fixed an issue where activating the Pro plugin while the Free plugin was active, or vice versa, would cause a fatal error.

= 4.0.3 =

* Bug fixes:
    * Shortcode attributes were not properly sanitized.
    * Cache keys were not being generated correctly resulting in duplicate cache keys.
    * Custom CSS styles were not loaded correctly when using the Related Posts Widget only.

= 4.0.2 =

* Enhancements:
    * Optimized cache clearing operations by using direct SQL queries. The cache clear button will also return the number of keys deleted. Optimized cache key generation to improve performance and reduce number of cache keys.

* Bug fixes:
    * Fixed an issue where Exclude Posts stopped working.

= 4.0.1 =

* Modifications:
    * Added new admin notice if any fulltext indexes are missing.

* Bug fixes:
    * The `post_content` index was not created.

= 4.0.0 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v4-0-0/](https://webberzone.com/blog/contextual-related-posts-v4-0-0/)

* Features:
    * [Pro] New: Efficient Content Storage and Indexing - Custom tables implementation for better performance and query optimization while maintaining the same relevance algorithm
    * [Pro] Added MAX_EXECUTION_TIME hint to MySQL queries. You can now set the maximum execution time for CRP queries in the Settings page.
    * [Pro] New setting to configure cache time for related posts with options ranging from 1 hour to 1 year.
    * [Pro] Added new setting to add tracking parameters to related post URLs. The following UTM parameters will be added:
        * `utm_source`: `contextual-related-posts`
        * `utm_medium`: `related-posts`
        * `utm_campaign`: `crp-plugin`
        * `utm_content`: `{source-post-id}-to-{target-post-id}`
    * [Pro] Introduced a feature to designate cornerstone posts, which are key articles or pages on your site. These cornerstone posts will appear at random positions in the related posts list, ensuring they receive more visibility and help guide your audience to the most important content on your site.
    * [Pro] New: Taxonomy weight system for more precise matching

* Enhancements/Modifications:
    * Enabled drag-and-drop functionality for reordering manual posts in the Metabox.
    * Added new `parse_wp_query_arguments` helper method to parse the comma-separated list of IDs and convert them to arrays for WP_Query compatibility
    * Renamed class CRP() to CRP_Core_Query()

= 3.6.2 =

* Bug fixes:
    * Fixed upgrade link in WordPress multisite.
    * Fix type casting for row height calculation in thumbs_grid style in Styles Handler class.
    * Updated Freemius SDK to v2.11.0.

= 3.6.1 =

* Bug fix: Corrected thumbnail images to return the specified image size instead of the full size.

= 3.6.0 =

Release post: [https://webberzone.com/announcements/contextual-related-posts-v3-6-0/](https://webberzone.com/announcements/contextual-related-posts-v3-6-0/)

* Features:
    * [Pro] New block: Contextual Related Posts Featured Image is an advanced featured image block that falls back to the first image, meta key, or a default image if no featured image is set.
	* [Pro] Related Posts block now includes:
		* Buttons to save and clear default block settings.
		* Auto-insertion of default and global settings attributes, with an option to disable this in the **List tuning** tab.

* Modifications:
    * The "Manual related posts" field in the meta box can now be customized to perform searches without relevance. To disable relevance in searches, use the filter `crp_meta_box_manual_related_relevance` with the following code: `add_filter('crp_meta_box_manual_related_relevance', '__return_false');`.
    * Contextual Related Posts Block's Other attributes moved to Advanced panel.
    * Show admin notices when the Style is set to "Rounded Thumbnails", "Rounded Thumbnails with Grid", or "Text Only" in the Settings page. A notice will appear below the affected settings, indicating that these options cannot be modified.
    * Updated "Rounded Thumbnails" style's post title line height to 1.1em and removed the padding.
    * Updated Freemius SDK to 2.10.1.

* Bug fixes:
    * Fixed warning message about language files being initiated too early.

= 3.5.5 =

* Modifications:
    * Updated Freemius SDK to 2.9.0

= 3.5.4 =

Release post: [https://webberzone.com/announcements/contextual-related-posts-v3-5-0/](https://webberzone.com/announcements/contextual-related-posts-v3-5-0/)

* Fixes:
    * `include_post_ids` and `manual_related` were not being passed correctly to the query

= 3.5.3 =

* Modifications:
    * Updated Freemius SDK to 2.7.3
    * Updated Contextual Related Posts block apiVersion to 3
    * Increase background opacity for the Rounded Thumbs style's post title for better readability

* Fixes:
    * Allow `manual_related` attribute in shortcode
    * Correctly handle manual_related and include_post_ids arguments when set to 0. Ensure manual_related is set to an empty array when 0 is passed.
    * Correctly check if `relation` attribute is set for meta_query and tax_query
    * Fixed links to settings and tools page in the admin area
    * Pass `post_status` when using `get_posts()`
    * Remove `the_posts` filter in CRP_Query
    * [Pro] Fixed bug in the Query Loop where custom post types didn't appear in the dropdown

= 3.5.2 =

* Modifications:
    * [Pro] If "Only from" same category/tag/taxonomy is enabled, the plugin will sort results by the number of matched taxonomies first, then optimize the related posts further. The free version will continue to sort by date
    * [Pro] If any of the weights are 0, then the algorithm will not consider that field for matching

* Bug fix:
    * Custom styles did not get enqueued on the front end
    * Fixed PHP error on the Network admin page
    * Fixed bug where post types and taxonomies settings retained the previous values if no option was selected

= 3.5.1 =

* Bug fix:
    * Fixed memory issue when using the crp shortcode

= 3.5.0 =

Complete code rewrite using OOP, namespacing and autoloading. This will make it easier to maintain and extend the plugin in the future.

* Features:
    * Enter a negative number in the "Insert after paragraph number" setting to insert the related posts from the bottom of the post
    * [Pro] New Related Posts Query Block that allows you to query related posts using a block in the block or site editor
    * [Pro] New feature to set the weight of the title, content and excerpt in the related posts algorithm
    * [Pro] New parameter `display_only_on_tax_ids` to display related posts only on specific taxonomy terms
    * [Pro] New option added to the Edit Post meta box mapped to `include_cat_ids` to include related posts from specific categories only
    * [Pro] New *Clear cache* button in the settings page to clear the cache

* Enhancements:
    * The plugin supports `WP_Query` directly if `crp_query` is set in the query arguments
    * Optimized media handler to reduce the number of queries
    * _Cache posts only_ setting is changed to be true by default
    * _Cache HTML output_ will now cache the HTML output of the related posts list, superseding the _Cache posts only_ setting

* Bug fix:
    * `trim_char` function returned a blank string instead of the original string if the length was 0
    * Insert after paragraph used to insert after an extra paragraph than what was specified

= 3.4.2 =

Release post: [https://webberzone.com/announcements/contextual-related-posts-v3-4-0/](https://webberzone.com/announcements/contextual-related-posts-v3-4-0/)

* Enhancements:
    * Live Search in the Manual Related Posts field now searches by post ID if you enter a number
    * Live Search will only search for posts titles and not content
    * Include Words feature will now try to sort the posts by the number of words matched in the title, content and excerpt

* Bug fix:
    * Bug in Include Words functionality where all post types were incorrectly included
    * Compatibility issue with PolyLang. Return the default post if pll_get_post returns false

= 3.4.1 =

* Bug fix:
    * Fixed Request-URI Too Long error when searching for pages/posts
    * Related Posts block threw an error when using on the widgets page

= 3.4.0 =

* Features:
    * Bulk edit posts, pages and custom post types to add the manual relatd posts and/or exclude posts from the related posts list
    * New argument `include_words` to include posts that match the words in the title and/or content.

* Enhancements/Modifications:
    * The Manual Related Posts field in the meta box allows a user to live search for related posts
    * Caching of the entire HTML output is enabled by default. You can disable it in the settings page. This will reduce the number of database queries and improve performance. If you have customised the output, you will need to clear the cache for the changes to take effect. Applies to new installs and when you reset the settings
    * The plugin no longer check for pre v2.5 settings key
    * The Media Handler will check the title of the image in case the alt tag text is empty before defaulting to the post title
    * All the inbuilt styles have been updated for the `a` tags to have `:focus-visible` declared for accessibility
    * The `Heading of posts` setting will now use `<h2>` instead of `<h3>` for the heading by default

* Bug Fixes:
    * The post cache was not always cleared when a post was updated

* Deprecated:
    * `get_crp_posts_id` has been completed deprecated and will use `get_crp_posts` instead. The function will continue to work but will be removed in a future version

= 3.3.4 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v3-3-0/](https://webberzone.com/blog/contextual-related-posts-v3-3-0/)

* Enhancements/Modifications:
	* When displaying the post thumbnail, the Media Handler will first use the image's alt tag set in the Media editor. If alt tag is empty, then it will use the post title as a fallback. Filter `crp_thumb_use_image_alt` and set it to false to not use the alt tag. Filter `crp_thumb_alt_fallback_post_title` and set it to false to disable the alt tag
	* Orderby clause modified to ensure compatibility if any other plugin rewrites the WP_Query fields

* Bug Fixes:
    * Fix duplicate display of related posts when using reusable blocks or a plugin that inserts pages
    * `meta_query` argument was ignored

= 3.3.3 =

* Fixes permission issues with HTML settings

= 3.3.2 =

* Clearing cache security fix

= 3.3.1 =

* Security fix in block

= 3.3.0 =

* Features:
    * Related posts block allows you to set a custom header above the related posts. Leave blank to get the one from the main settings page.
    * New option "Related Meta Keys" under the List Tuning tab. You can enter a comma-separted list of meta keys. Posts that match the same value of the meta key are displayed before the other related posts.

* Enhancements/modifications:
    * If the number of "Manual related posts" is greater than the number of related posts, then the database query is bypassed drastically improving perfomance
    * Moved Related Posts Tools page under Tools menu
    * Related Posts block is now wrapped in `Disabled` tags to prevent accidental clicking of links in the block editor

* Bug fixes:
    * Thumb width and height defaults to 150 in case the settings are missing
    * Setting the style to be text_only didn't enforce no thumbnail

* Developer:
    * New filters: `crp_query_date_query`, `crp_query_meta_query`, `crp_query_meta_query_relation`
	
= 3.2.3 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v3-2-0/](https://webberzone.com/blog/contextual-related-posts-v3-2-0/)

* Enhancements:
    * Block shows a placeholder when used in non-Edit screens or when no content is generated

* Bug fix:
    * Missing text-only.min.css file
    * Block settings were not saved

= 3.2.2 =

* Bug fix:
    * Widget options were not saved properly
    * Stylesheets and header styles have been fixed to be more specific

= 3.2.1 =

* Enhancements/modifications:
    * If thumbnail is set as `text only`, then the style is also set as `text only` at runtime

* Bug fix:
    * PHP error thrown when using `get_crp_posts_id()`

* Deprecated:
    * `get_crp_posts_id()`. Use `get_crp_posts()` instead

= 3.2.0 =

* New feature:
    * New option to limit posts to the primary category/term. The plugin checks if either Yoast, Rank Math, The SEO Framework or SEOPress are active. If none of these are active, the plugin will pick the first category provided by `get_the_terms()`
    * New option to show the primary category/term
    * New option in metabox to enter a comma-separated list of post IDs to exclude from the related posts
    * New filter `crp_fill_random_posts` (default:false) which can be used to fill random posts if the number of related posts is less than the limit set

* Enhancements/modifications:
    * No widget is displayed if `get_crp()` is empty i.e. no related posts are found
    * `post_title` and `post_content` fields are only used if *Use content* option is set
    * Gutenberg block updated to the latest Blocks API
    * The widget's "Only from categories" autocomplete replaced by ID list
    * Wrapper `div` now always includes `crp_related` class name. Stylesheets have been updated to have more specific styles e.g. `.crp_related.crp-rounded-thumbs`

* Bug fixes:
    * Current post was incorrectly being excluded in the translation functions

= 3.1.1 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v3-1-0/](https://webberzone.com/blog/contextual-related-posts-v3-1-0/)

* Enhancements:
    * Don't clear cache when saving settings. The cache can be cleared in the Tools page
    * Default thumbnail is now prioritized over the site icon

* Bug fixes:
    * Limiting of characters didn't work properly
    * Fixed link to Tools menu under Settings. Tools button link is better displayed
    * Fixed activation when new blog is created on multisite

= 3.1.0 =

* Features:
    * REST API support - you can now fetch the related posts via the REST API. Fetch posts at `/contextual-related-posts/v1/posts/<id>`
    * New setting in the metabox to exclude specific terms

* Enhancements/modifications:
    * Thumbnail function uses the size instead of exact array of sizes to better select the appropriate thumbnail image size
    * Use site icon if no other thumbnail is found
    * Use both `post_title` and `post_content` fields for matching even when match content setting is off
    * Passing `post_type` and `posts_per_page` arguments will be respected instead of being overridden

* Bug fixes:
    * Don't enqueue wp-editor on widgets.php
    * [WP_Query stopwords](https://developer.wordpress.org/reference/classes/wp_query/get_search_stopwords/) are stripped from content that is matched
    * Manual posts are added after the automatic posts are shuffled

= 3.0.7 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v3-0-0/](https://webberzone.com/blog/contextual-related-posts-v3-0-0/)

* Bug fix:
    * Replicate old style of exclusion checking of option set in meta. Using the shortcode, manual or block will ignore the meta option to "Disable Related Posts display"

= 3.0.6 =

* Enhancement:
    * Defining `CRP_CACHE_TIME` to `false` will disable expiry
    * Introduced wpml-config.xml file. Title and Custom text for blank output can now be translated with Polylang (and potentially WPML)

* Bug fix:
    * Exclude on categories did not work
    * Posts would trigger a "SHOW FULL COLUMNS FROM" error if they had ' from' in the title
    * Manual posts did not work properly - all post types and all posts are properly fetched now

= 3.0.5 =

* Bug fix:
    * Certain posts would trigger a "SHOW FULL COLUMNS FROM" error
    * Forced `.crp_related figure` margin to 0

= 3.0.4 =

* Enhancement/Modifications:
    * `include_cat_ids` and `exclude_categories` will also accept custom taxonomy `term_taxonomy_id`s
    * Thumbnail's `img` tag is wrapped in `<figure>`
    * Remove extra checking for `exclude_categories` in `get_crp`
    * Optimise deleting of cache entries when updating a post - post saving should be significantly faster

= 3.0.3 =

* Enhancement/Modifications:
    * Grid style minimum width is now decided by the width of the thumbnail and long words are wrapped

* Bug fixes:
    * Selecting No style created a 404 error
    * Fixed issue with $attachment_id not being declared in some cases

= 3.0.2 =

* Bug fixes:
    * Fixed issue where Related Posts newer than was set to 0 caused no posts to display
    * Use the original arguments when setting the cache key for CRP_Query
    * Selecting "Blank Output" didn't work

= 3.0.1 =

* Bug fixes:
    * Fixed issue with help tab that broke some sites

= 3.0.0 =

* Features:
    * New CRP_Query class for fetching related posts. This replaces `get_crp_posts_id()` which will be deprecated in a future version
    * CRP Thumbnails now include the `loading="lazy"` attribute added in WordPress 5.5
    * New parameter `more_link_text` that can be passed to `get_crp()` which holds the "read more". Recommended option to customize the more link text using the filter `crp_excerpt_more_link_text` or the more link element using `crp_excerpt_more_link`
    * Three new styles: "Masonry" (like Pinterest), "Grid" and "Rounded thumbnails with CSS grid". Might not work with older browsers
    * Imported settings of [Related Posts by Categories and Tags](https://webberzone.com/downloads/crp-taxonomy/). That plugin is now deprecated with this release.

* Enhancement/Modifications:
    * If WPML or PolyLang are active, `get_crp_posts_id()` and `CRP_Query` will return the translated set of post IDs and external processing is no longer needed
    * Use `wp_img_tag_add_srcset_and_sizes_attr()` to generate srcset and sizes attributes. The original code to display the srcset and sizes attributes will continue to be used
    * Improved caching with inbuilt expiry. Use CRP_CACHE_TIME in your wp-config.php to set how long the cache should be set for. Default is one month
    * CRP_MAX_WORDS has been reduced to 100
    * Dropped the need for FULLTEXT index on post_content which should save some database space
    * Deprecated the following filters: `get_crp_posts_id`, `crp_posts_now_date`, `crp_posts_from_date`, `crp_posts_fields`, `crp_posts_join`, `crp_posts_where`, `crp_posts_groupby`, `crp_posts_having`, `crp_posts_orderby`, `crp_posts_limits`, `get_crp_posts_id_short_circuit`

* Bug fixes:
    * In the settings page, only built-in taxonomies were being incorrectly displayed
    * If "before list item" is empty, then the output was blanked out
    * Settings help has been fixed
    * `crp_get_option` would return an incorrect value if $crp_settings global variable was not set

= 2.9.4 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v2-9-3/](https://webberzone.com/blog/contextual-related-posts-v2-9-3/)

* Bugs:
    * Fixed nonce verification not always done in Import/Export interface. Thanks to [Lenon Leite](https://github.com/lenonleite)

= 2.9.3 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v2-9-3/](https://webberzone.com/blog/contextual-related-posts-v2-9-3/)

* Features:
    * New constant `CRP_VERSION` to hold the current version of the plugin
    * New setting to delete FULLTEXT indices on deactivation

* Enhancements:
    * Added the `$args` attribute to the filters in main-query.php

= 2.9.2 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v2-9-0/](https://webberzone.com/blog/contextual-related-posts-v2-9-0/)

Bug fixes:
    * Password protected posts will no longer show the excerpt

= 2.9.1 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v2-9-0/](https://webberzone.com/blog/contextual-related-posts-v2-9-0/)

Bug fixes:
    * Custom CSS box would not save and get cleared out when saving settings
	* `include_cat_ids` didn't work with the shortcode

= 2.9.0 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v2-9-0/](https://webberzone.com/blog/contextual-related-posts-v2-9-0/)

* Features:
    * New section under Settings > Related Posts > Tools to export and import settings. Best option if you'd like the same configuration across multiple WordPress sites
	* New shortcode setting `include_cat_ids` to limit top posts to selected categories/taxonomies. Use a comma separated list of [term_taxonomy_id](https://codex.wordpress.org/WordPress_Taxonomy#wp_term_taxonomy)
	* New setting in widget to only include certain categories. Doesn't work with custom taxonomies

* Enhancements:
    * New function: `crp_get_thumb_size()` to get the correct size of the thumbnail
    * Only run a get_post query if only the post ID is passed to `crp_get_the_post_thumbnail()`
    * `$match_fields` parameter added to `crp_query_posts_match` filter
    * Updated WPML functions to use latest filters
	* Admin scripts are no longer loaded into the head - but using a separate JavaScript file
	* Implemented CodeMirror to format custom styles box
    * New filters `get_crp_short_circuit` and `get_crp_posts_id_short_circuit` to bypass outputs and queries
    * `CRP_MAX_WORDS` has been reduced from 500 to 250 to avoid "Too many words" mySQL error
    * The link to the Contextual Related Posts link is no longer a list item but a smaller text paragraph below the items. You can turn this on by enabling Show Credit.

* Bug fixes:
    * Fixed errors created when trying to fetch a featured image or scanned images with remote links
    * Saving categories fields in the settings page uses `str_getcsv` and a custom function `crp_str_putcsv`

= 2.8.0 =

Release post: [https://webberzone.com/blog/contextual-related-posts-v2-8-0/](https://webberzone.com/blog/contextual-related-posts-v2-8-0/)

* Features:
    * New block for Gutenberg aka the block editor. The block is called **Related Posts [CRP]** and you can find it under the widgets category
    * Two new settings in the widget: **Order posts** and **Randomize order** that allows the global setting to be overridden
    * New setting called **Keyword** in the Meta box where you can enter a word or a phrase to find related posts. If entered, the plugin will continue to search the `post_title` and `post_content` fields but will use this keyword instead of the values of the title and content of the source post

* Enhancements:
    * Show author, Show date, Show post excerpt and Post thumbnail settings will show a message that they cannnot be modified in case the Rounded thumbnails or No text styles are selected

* Bug fixes:
	* Selecting date order now orders the related posts by newest first
    * Fixed PHP warning in the widget
    * Stop using `current_time( 'timestamp' )`
    * Fixes incorrect thumbnail image displayed for attachments in the related posts list

= 2.7.0 =

* Features:
	* Caching improvements: "Enable cache" has been renamed to "Cache HTML output". New option "Cache posts only" has been introduced to cache the output of the database query (array of posts)
	* New option to order posts by relevance, dates or randomly
	* New option to limit posts by the same author
	* Thumbnail HTML markup includes `srcset` and `sizes` attributes when available. Read [Responsive Images in WordPress 4.4](https://make.wordpress.org/core/2015/11/10/responsive-images-in-wordpress-4-4/)

* Enhancements:
	* No longer use `get_the_title`. You can use `crp_title` and/or `crp_thumb_title` filters to edit the post title and the alt/title attributes of the thumbnail respectively
	* Selecting Rounded thumbnails under Styles tab will allow your thumbnail setting to either be "inline before text" or "only thumbnails, no text"

= 2.6.3 =

* Enhancements:
	* Optimized versions of default.png and default2.png

* Bug fixes:
	* Fixed PHP error when viewing feed
	* "Exclude categories" setting wouldn't save properly
	* Delete any deprecated settings on save should work properly
	* Clearer messages when saving options and a style is activated

= 2.6.2 =

* Bug fixes:
	* Fixed PHP fatal error "Can’t use function return value in write context"
	* Changed default setting for thumbnail width and height to 150

= 2.6.1 =

* Features:
	* New options to delete options and/or data on uninstall. This will only work if you visit the Settings page and save the pages.

* Bug fixes:
	* Custom CSS code should now be properly added to the header
	* Upgrading settings when "Automatically add related posts to" had no options checked should work properly

= 2.6.0 =

* Features:
	* Implemented the Settings API for handling plugin settings
	* New Tools page: Recreate the indices, delete the cache and delete old settings

* Enhancements:
	* `widget_title` filter includes `$instance` and `id_base` variables

* Bug fixes:
	* Checked for non-zero thumbnail width and height in the widget
	* More checks for PHP errors and notices

= 2.5.1 =

* Features:
	* New option to disable creation of thumbnails

* Enhancements:
	* Do not delete index on activation
	* crp_thumbnail image size will set the default crop option to true if not already set

* Bug fixes:
	* Missing/Unknown PHP errors/warnings in the widget
	* Minor CSS fixes

= 2.5.0 =

* Features:
	* New option to disable related posts on mobile devices
	* New option to disable related posts on AMP pages

* Enhancements:
	* New filters `crp_thumb_alt` and `crp_thumb_title` to edit the post thumbnail alt and title tags. Use this to remove/replace the tags
	* New function and filter `crp_permalink`
	* Saving a post will delete its cache

* Bug fixes:
	* Fixed CSS validation errors
	* Removed conversion of table schema from/to InnoDB. If you are using a version of mySQL above v5.6, you can alter the table engine to use InnoDB with a FULLTEXT index
	* Prevent errors from non-existent post id (virtual post). Contributed by [@jnorell](https://github.com/jnorell)

= 2.4.1 =

* Bug fixes:
	* Reverted the "Automatically add related posts to" setting introduced in 2.4.0
	* Metaboxes will now save when editting attachments

= 2.4.0 =

* Features:
	* New option to randomize the related posts
	* New option to limit related posts to the same post type
	* "Automatically add related posts to" option applies to widgets

* Enhancements:
	* `post_types` argument now takes a comma-separated list of post types. Default format when resaving options is also comma-separated

* Bug fixes:
	* Trimming titles should now work with multibyte / non-English characters

* Deprecated:
	* `crp_max_formatted_content` has been deprecated. Use `crp_trim_char` instead

= 2.3.1 =

* Bug fixes:
	* Replaced `.crp_title` wrapper from `div` to `span`. Empty the cache via the settings page and also your browser cache

= 2.3.0 =

* Features:
	* Shortcode and the widget now have an added parameter for 'offset'. This is useful if you would like to display different widgets/shortcodes but not always start from the first post
	* New option in metabox: "Exclude this post from the related posts list"
	* New option: Insert after nth paragraph

* Enhancements:
	* The generated HTML code uses a single `a href` tag rather than two separate ones per item which is usually better for SEO. If you're not using the Rounded Thumbnail style and using your own custom style, then you might need to reconfigure this
	* New constant `CRP_MAX_WORDS` (default 500) limits the post content to be compared. Add this to your `wp-config.php` file to overwrite

* Bug fixes:
	* Language files initialisation had the wrong text domain
	* Stop updating the thumb settings if the existing value isn't found. Caused incorrect changes in certain installations
	* Force link text to white when using Rounded Thumb style
	* The plugin will no longer generate any notices if post author is missing

* Deprecated:
	* Removed wick for exclude categories auto-suggest. Plugin now uses jQuery Suggest that is included in WordPress. When you re-save plugin options, the field will convert the slugs to the category name
	* Deprecated `$crp_url`. Use the new constants `WZ_CRP_PLUGIN_DIR`, `WZ_CRP_PLUGIN_URL` and `CRP_PLUGIN_FILE`

= 2.2.3 =

* Enhancements:
	* Changed text domain to `contextual-related-posts` in advance of translate.wordpress.org translation system
	* Improved support for WPML. If available, same language posts will be pulled by default. To restrict to the same language [add this code](https://gist.github.com/ajaydsouza/9b1bc56cec79295e784c) to your theme's functions.php file
	* Removed `id` tag from related posts HTML output to make it W3C compliant. If you're using the id with your custom styles, please change this to classes i.e. change `#crp_related` to `.crp_related` and it should work

* Bug fixes:
	* All cache entries were not deleted on uninstall

= 2.2.2 =

* Features:
	* Preliminary support for WPML

* Enhancements:
	* Recreate Index and Activation will not try to alter the table engine if not needed

* Bug fixes:
	* All thumbnail classes were not properly applied + new thumbnail class filter
	* Shortcode with "exclude_categories" argument works again

= 2.2.1 =

* Bug fixes:
	* "No styles" would not get selected if "Rounded thumbnails' was enabled
	* "Recreate Index" caused a fatal error: Call to undefined function `crp_single_activate()`
	* Excerpt shortening was not working correctly
	* Exclude categories wasn't working in some cases
	* Additional check to see if default styles are off, then force No style

= 2.2.0 =

* Features:
	* Manual posts can now be set in the meta box in the Edit Post screens which will be displayed before the related posts fetched by the plugin
	* Choose between No style, Rounded thumbnails (previously called default style) and Text only style options under the Styles box in the plugin settings page
	* Option to turn off the Contextual Related metabox on Edit Posts screens or limit it to Admins only. Also applies to Pages and Custom Post Types
	* Filter `crp_link_attributes` that allows a user to add or remove attributes for the `a` tag
	* Notice is displayed at the top of the Settings page if there are any missing of the FULLTEXT indices missing
	* Option in the Contextual Related Posts meta box to disable the related posts on the selected post
	* Select post type in the Related Posts Widget

* Enhancements:
	* Optimised number of queries for exclude categories option. Those not using this option will see the greatest savings
	* Select a pre-built thumbnail size will automatically update the width, height and crop settings. The default style will no longer enforce the 150x150 thumbnail size.
	* `strict_limit` argument in `get_crp_posts_id` is now TRUE by default
	* `get_crp` takes an additional argument: `heading` (default is TRUE) that controls the display of the main heading (**Related Posts**)
	* Output of `echo_crp` will be cached in a separate meta key

* Bug fixes:
	* First child now gets the correct thumbnail size

* Deprecated:
	* `ald_crp()` - `Use get_crp()` instead
	* `ald_crp_content()` - `Use crp_content_filter()` instead
	* `ald_crp_rss()` - `Use crp_rss_filter()` instead
	* `echo_ald_crp()` - `Use echo_crp()` instead

= 2.1.1 =

* Enhancements:
	* Settings page now clearly highlights what options cannot be changed if the default styles are enabled, i.e. thumbnail settings and no excerpt, author or date

= 2.1.0 =

* Features:
	* Separate cache for related posts added to feeds. Prevents conflict with the cache for normal related posts
	* Timthumb has been deprecated
	* Setting "Related posts should be newer than:" to 0 to disable limiting posts by age
	* Filters `crp_posts_match`, `crp_posts_now_date`, `crp_posts_from_date` to modify the WHERE clause

* Enhancements:
	* `thumb_timthumb`, `thumb_timthumb_q` and `filter` attributes for the function `crp_get_the_post_thumbnail` have been deprecated. If you're using this function, an entry will be created for the deprecated log
	* Reset default thumbnail URL location to plugin default if the field is blank or only contains `/default.png`
	* Meta-box will no longer be displayed on non-public post types
	* For first image, the plugin will attempt to seek the correct thumbnail size if available

* Bug fixes:
	* Author link was incorrectly displayed multiple times in the list when Show Author was enabled
	* WP Notice Errors when using the Widget via the Customizer menu in WordPress
	* Incorrect thumbnail was pulled on attachment pages

= 2.0.1 =

* Bug fixes:
	* Clear Cache button which broke in 2.0.0

= 2.0.0 =

* Features:
	* Multi-site support. Now you can Network Activate the plugin and all users will see related posts!
	* Thumbnails are registered as an image size in WordPress. This means WordPress will create a copy of the image with the specified dimensions when a new image is uploaded. For your existing images, I recommend using <a href="https://wordpress.org/plugins/force-regenerate-thumbnails/">Force Regenerate Thumbnails</a>
	* Completely filterable mySQL query to fetch the posts. You can write your own functions to filter the fields, orderby, groupby, join and limits clauses

* Enhancements:
	* Lookup priority for thumbnails. The thumbnail URL set in the Contextual Related Posts meta box is given first priority
	* Removed `border=0` attribute from `img` tag for HTML5 validation support
	* Default option for timthumb is disabled
	* Default option for post types to include is post and page
	* `get_crp_posts` has been deprecated. See `get_crp_posts_id` instead
	* Turning on the Default style will switch on thumbnails, correctly resize them and will also hide authors, excerpts and the post date

* Bug fixes:
	* Post image will now be loaded over https if the visitor visits your site on https

= 1.9.1 =
* New: Meta box on the Edit Posts, Pages and custom post type pages to easily add the location of the URL of the thumbnail image
* Modified: Refined match title algorithm. Previously this would match the post title with both the title and content
* Modified: Widget initialisation
* Modified: Massive code cleanup and more documentation in the WordPress settings page
* New: Added w.org and github.com to list of allowed sites for timthumb

= 1.9.0.1 =
* Fixed: Add to feeds was broken in v1.9

= 1.9 =
* New: Default style to make those related posts look awesome! You can find this option in the Custom styles section
* New: Option to change the priority of the content filter. Now you can choose at what stage after the content the related posts are added.
* New: Option to exclude the display on custom post types. Find this under Output Options
* New: Redesigned settings page to be more responsive on mobile devices and better integrated in the WordPress Dashboard design
* New: Function `get_crp_posts_id` can be used to fetch the IDs of related posts. Check out the FAQ on details of this
* Modified: Shortcode now considers a wider range of attributes

= 1.8.10.2 =
* Fixed: Potential SQL vulnerability - Thanks to <a href="http://www.flynsarmy.com/">flynsarmy</a> for highlighting this
* Modified: Minor performance improvements in initialisation of the widget
* Modified: Plugin now checks if it is within the loop when any option under "Add related posts to:" is selected. Minor performance increase to avoid the plugin being called unnecessarily in secondary loops.

= 1.8.10.1 =
* Fixed: Manual install caused a PHP error in 1.8.10

= 1.8.10 =
* New: Limit the numbers of characters of the content being compared. This can give a marginal boost to performance
* New: You can now choose to display the Post title in the Title of the Related posts, by using %postname%
* Modified: Widget class has been changed to `crp_related_widget`
* Modified: Including the author in the list will now use the Display Name which is set under “Display name publicly as” in the User Profile page
* Modified: Updated timthumb
* Modified: Better handling of `echo_ald_crp` - Thanks to <a href="http://www.flynsarmy.com/">flynsarmy</a> for this patch
* Fixed: If the Thumbnail meta field is omitted under Output Options, the plugin will automatically revert to its default value i.e. "post-image"
* Modified: More descriptions for the various options

= 1.8.9.1 =
* Fixed: PHP error when fetching thumbnail for gallery posts

= 1.8.9 =
* New: Option to choose between using CSS styles or HTML attributes for thumbnail width and height. *HTML width and height attributes are default*
* New: Filters `crp_title` and `crp_heading_title` can be used to customise the Title of the posts and Heading Title of posts list respectively. Check out the FAQ for further information
* New: Option to add the author to the list of posts
* New: Options in the widget to show author and date
* New: Bypass cache option for `echo_ald_crp`. This is the default option. You can force the cache using `echo_ald_crp($cache=true)`
* Modified: Shortcodes are now stripped from excerpts
* Fixed: Lists for the widget and for in-post have independent caches to prevent overlap
* Modified: Saving widgets settings will clear the widget cache
* Fixed: Plugin will now create thumbnails from the first image in gallery custom posts
* Fixed: Uninstall script should now clean the cache as well

= 1.8.8 =
* New: Clear cache button
* New: Option to add the date before the post title

= 1.8.7 =
* Important security update: Potential XSS vulnerability fixed. Thanks to Charlie Eriksen via Secunia SVCRP for reporting this
* Added Latvian translation

= 1.8.6 =
* New: Related posts are now cached
* New: New function <code>get_crp_posts</code> to get only the list of posts in an array. Check the <a href="http://wordpress.org/extend/plugins/contextual-related-posts/faq/">FAQ</a> on how to use it.
* New: Timthumb will now resize images on wordpress.org, wordpress.com and wp.com. The latter two are useful if you're running Jetpack
* New: Shortcode functionality. You can use the shortcode `[crp]` to display the related posts. Check the FAQ for further details.
* Fixed: Exclude category option missed the last category in the list
* Fixed: Open links in new window option was not working

= 1.8.5 =
* New: Option to open links in new window - Find this under Output Options
* New: Option to add <code>rel="nofollow"</code> to links - Find this under Output Options
* New: Option to set quality of thumbnails - Find this under Output Options
* New: Custom text to display if no related posts are found - Find this under Output Options
* New: Thumbnail height and width can now be configured for the widget
* Fixed: Filter (<code>crp_postimage</code>) added for WordPress Post Thumbnails to allow you to modify your image with your own script. Plugin comes inbuilt with thumbnail resizing using timthumb
* Fixed: PHP notices when WP_DEBUG is set to true

= 1.8.4 =
* New: Option to exclude display of related posts on certain posts/pages. This option is available under "Output Options"
* New: Options to display related posts on home page, category archives, tag archives and other archives
* New: Option to set how recent the related posts should be
* New: Option to limit post title length
* Modified: Filter (<code>crp_postimage</code>) added for WordPress Post Thumbnails to allow you to modify your image with your own script. Plugin comes inbuilt with thumbnail resizing using timthumb
* Modified: If the option to scan for the first image in the post is set to ON, then only images from the same domain as your blog are used as thumbnails. External images are ignored.
* Modified: Updated to latest version of timthumb
* Fixed: Widget now displays on posts and page correctly. Previously displaying the widget resulted in duplicate display of related posts
* Fixed: Related Posts now display correctly in feeds when feed content is set to "Summary"
* Fixed: Fixed PHP Notices: "Use of undefined constant"
* Fixed: Custom CSS styles will be included in the header of all posts and pages. On archives it will be included depending on the settings

= 1.8.3 =
* Fixed: PHP warning errors on manual code for sites with PHP error reporting turn on in strict mode
* Modified: Fixed some language related issues. If you would like to translate the plugin or update a translation, please <a href="https://webberzone.com/contact/">contact me</a>.

= 1.8.2 =
* Fixed: PHP warning errors for sites with PHP error reporting turn on in strict mode

= 1.8.1 =
* New: Widget support. Widget display follows the same settings as having the related posts after content.
* New: Exclude posts and pages by ID
* Modified: Optimised performance when automatic insertion into content is turned off
* Modified: Plugin uses the default excerpt if it is set, else it creates one based on content. Both settings respect the excerpt length set in the plugin
* Modified: Fixed some language related issues. If you would like to translate the plugin or update a translation, please <a href="https://webberzone.com/contact/">contact me</a>.
* Deleted: Redundant option to exclude display of the related posts on pages. You can use the custom post types feature instead
* New: Chinese language file

= 1.8 =
* Modified: Replaced `id` attribute with `class` tag on non-singular pages. On singular pages it will display both `id` and `class`
* New: Option to use timthumb to create thumbnail images (turned ON by default)
* New: Support for WordPress Custom Post Types
* New: New `Custom Styles` tab to allow you to easily style the output
* Modified: New "default.png" file based on from KDE’s <a href="http://www.oxygen-icons.org/">Oxygen icon set</a>

= 1.7.3 =
* Fixed: Donation link

= 1.7.2 =
* Fixed: Title attribute was missing for the thumbnails
* Modified: Reverted the output code to v1.6.5 style with `img` wrapped in its own `a` tag

= 1.7.1 =
* Fixed: Minor bug fix for location of thumbnail

= 1.7 =
* New: New function <code>related posts()</code> that allows you to manually add posts to your theme
* New: Support for <a href="https://wordpress.org/extend/plugins/video-thumbnails/">Video Thumbnails</a> plugin
* New: Thumbnail settings now reflect max width and max height instead of fixed width and height
* New: Option to display thumbnails before or after the title
* New: Option to not display thumbnails instead of the default thumbnail
* New: Plugin now uses InnoDB instead of MyISAM if your server is running mySQL v5.6 or higher
* Modified: Cleaner Settings page interface
* Modified: Updated <a href="http://wordpress.org/extend/plugins/contextual-related-posts/faq/">FAQ page</a>

= 1.6.5 =
* Fixed: Few code tweaks to optimise MySQL performance
* New: Dutch and Spanish language files

= 1.6.4 =
* Fixed: Undefined constants PHP errors

= 1.6.3 =
* Fixed: The plugin will now display a list of changes in the WordPress Admin > Plugins area whenever an update is available

= 1.6.2 =
* Turned the credit option to false by default. This setting won't effect current users.
* Turned off borders on post thumbnails. You can customise the CSS class "crp_thumb" to style the post thumbnail
* From the next version, the plugin will display update information in your WP-Admin

= 1.6.1 =
* Fixed: Custom output was not detecting styles properly
* Fixed: Incorrect XHTML code was being generated when using special characters in the post title

= 1.6 =
* New: The plugin extracts the first image in the post and displays that if the post thumbnail and the post-image meta field is missing
* New: Display excerpts in the list
* New: Credit link to the CRP page added. You can choose to turn this off, though I would appreciate if you leave it on.
* Updated: All parts of the list are now wrapped in classes for easy CSS customisation

= 1.5.2 =
* Fixed: Fixed display of post thumbnails using postmeta field

= 1.5.1 =
* Fixed: Numeric options were not being saved correctly

= 1.5 =
* Added an Option to display post thumbnails
* The output can be completely customised now

= 1.4.2 =
* Fixed: Using doublequotes in the title would mess up the screen
* Fixed: Errors when the mySQL index was being regenerated

= 1.4.1 =
* Added Italian and Danish languages
* Minor fix for text in the admin page

= 1.4 =
* Added complete localization support
* Added button to recreate the mySQL FULLTEXT index

= 1.3.1 =
* Fixed bug that didn't blank out posts even when option was selected

= 1.3 =
* Better optimization in WP-Admin area.
* Fixed compatibility problems with Simple Tags plugin
* Fixed large number of queries being generated

= 1.2.2 =
* Minor bug fixed about limit of posts

= 1.2.1 =
* Bug fixed to support PHP4

= 1.2 =
* Option to blank output in case nothing is found
* Exclude posts from certain categories
* Exclude pages
* Option to choose if you want related posts to be displayed on pages

= 1.1.1 =
* Now you can optionally choose if you want to use the post content to search for related posts

= 1.1 =
* Fixed MySQL index key conflicts by using a more unique index key name.

= 1.0.1 =
* Release

